import { useState } from 'react';
import { startOfMonth, getDaysOfMonth } from './utils';
export function useCalendar(month = new Date()) {
    const [currentMonth, setCurrentMonth] = useState(startOfMonth(month));
    const days = getDaysOfMonth(currentMonth);
    return {
        days,
        setMonth(date) {
            setCurrentMonth(date);
        },
        month: currentMonth
    };
}
