"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var utils_1 = require("./utils");
function useDateRange(initialStartDate, initialEndDate) {
    var _a = react_1.useState(initialStartDate), startDate = _a[0], setStartDate = _a[1];
    var _b = react_1.useState(initialEndDate), endDate = _b[0], setEndDate = _b[1];
    var selection = react_1.useRef(false);
    function handleDayClick(day) {
        if (startDate && selection.current && !utils_1.isDayBefore(day, startDate)) {
            setStartDate(startDate);
            setEndDate(day);
            selection.current = false;
        }
        else {
            setStartDate(day);
            setEndDate(undefined);
            selection.current = true;
        }
    }
    function handleDayHover(day) {
        if (startDate && selection.current && !utils_1.isDayBefore(day, startDate)) {
            setEndDate(day);
        }
    }
    function processMonth(month) {
        return month.map(function (week) {
            return week.map(function (day) {
                var isStart = Boolean(startDate && utils_1.isSameDay(day.date, startDate));
                var isEnd = Boolean(endDate && utils_1.isSameDay(day.date, endDate));
                return __assign({}, day, { selected: isStart || isEnd, inRange: isStart ||
                        isEnd ||
                        Boolean(startDate &&
                            utils_1.isDayAfter(day.date, startDate) &&
                            endDate &&
                            utils_1.isDayBefore(day.date, endDate)), isStart: isStart,
                    isEnd: isEnd });
            });
        });
    }
    return { handleDayClick: handleDayClick, handleDayHover: handleDayHover, startDate: startDate, endDate: endDate, processMonth: processMonth };
}
exports.useDateRange = useDateRange;
